# installs git
#
class git::install inherits git::params {
    case $::osfamily {
        'RedHat' : {
            $extract_dir = "/tmp/git-${git::params::version}"
            $filename = "v${git::params::version}.tar.gz"
            $packages = ['libcurl-devel', 'perl-ExtUtils-MakeMaker']

            package { $packages: }

            file { $extract_dir: ensure => 'directory' }

            archive { $filename:
                path         => "/tmp/${filename}",
                source       => "https://github.com/git/git/archive/${filename}",
                extract      => true,
                extract_path => '/tmp',
                cleanup      => true,
                require      => File[$extract_dir],
            }

            exec { "install git ${git::params::version}":
                command   => "/usr/bin/make configure && ${extract_dir}/configure --prefix=/usr/local && make install",
                cwd       => $extract_dir,
                unless    => "/usr/bin/ls ${git::params::git} && ${git::params::git} version | grep ${git::params::version}",
                subscribe => Package[$packages],
                require   => [Archive[$filename], Package[$packages]]
            }

            file { $git::params::git:
                ensure  => link,
                target  => '/usr/local/bin/git',
                require => Exec["install git ${git::params::version}"]
            }
        }
        default  : {
            fail("${::osfamily} unsupported")
        }
    }
}